Unit AM07C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AM07C(var A :Array of Complex; N :Integer; M :Integer;
                var B :Array of Complex);

implementation

procedure AM07C(var A :Array of Complex; N :Integer; M :Integer;
                var B :Array of Complex);
var
I,J,K :Integer;
R,E,A1 :Real;
S1,R1,R2,T,C,S :Complex;
label
_1,_2;
begin
for K:=1 to M do
 begin
  J := K+1;
  if ( J > N ) 
   then goto _2;
  for I:=J to N do
   begin
    T := A[(I-1)+(K-1)*N];
    E := Cabs(T);
    R := E*E;
    A1 := 1.0/(1.0+R);
    C := Cmplx((1.0-R)*A1,0.0);
    S := MulC((AddC(T,T)),Cmplx(A1,0.0));
    S1 := Conjg(S);
    R1 := B[K-1];
    R2 := B[I-1];
    B[K-1] := SubC(MulC(C,R1),MulC(S1,R2));
    B[I-1] := AddC(MulC(S,R1),MulC(C,R2));
_1:
   end;
_2:
 end;
end;

end.
